函数原型：
```
template<class InputIterator, class UnaryPredicate>
  InputIterator find_if (InputIterator first, InputIterator last, UnaryPredicate pred)
{
  while (first!=last) {
    if (pred(*first)) return first;
    ++first;
  }
  return last;
}
```


功能： 将区间【fist,last)之内每一个元素传入一元判断式：当pred(elem) 返回true时返回第一个达成条件的元素迭代器；

示例：

```
std::vector<int> numbers = {1, 2, 3, 4, 5, 6}; 
// 查找第一个大于4的元素 
auto it = std::find_if(numbers.begin(), numbers.end(), [](int n) { 
return n > 4; 
});
```